<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or 
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['superadmin','admin'],null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}


function getStaff($conn_rjllearning_specific, $institution_id, $branch_id,$search_string,$limit, $offset)
{

    $sql = "SELECT  count(*) as total_rows FROM  staff_details  where institution_id =? ";
    $array_params = [$institution_id];
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {
        $sql = "SELECT * FROM  staff_details WHERE institution_id = ?";
        $array_params = [$institution_id];
         if ($branch_id == 'all') {
            $sql .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }
        
        if ($search_string != null) {
            $sql .= " AND (name LIKE ? or email LIKE ? or phone LIKE ? )  ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
       
        $sql .=  "order by date_created desc, time_created desc";

    } else {

        $sql = "SELECT * FROM  staff_details WHERE institution_id = ?  ";
        $array_params = [$institution_id];
         if ($branch_id == 'all') {
            $sql .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }
       if ($search_string != null) {
            $sql .= " AND (name LIKE ? or email LIKE ? or phone LIKE ? )  ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
       
        
      $sql .= " order by date_created desc, time_created desc ";
      $sql .= "LIMIT " . $offset . " ," . $limit . "";
    
    }
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();

    $array_return = [];

    foreach ($result as $rows) {
         if($rows['print_bank_details'] == 1 and $rows['print_bank_details'] !=  null){
            $account_holder_name = $rows['account_holder_name'];
            $account_name = $rows['account_name'];
            $account_no = $rows['account_no'];
            $ifsc_code = $rows['ifsc_code'];
            $branch_address = $rows['branch_address'];
            $account_holder_name = $rows['account_holder_name'];
            $account_type = $rows['account_type'];
        }
        $branch_info =  getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        $array_return[] = array('staff_id'=> $rows['id'],'branch_id'=>$branch_info ,'name'=> $rows['name'],
        'email'=> $rows['email'],
        'phone'=> $rows['phone'],
        'address'=> $rows['address'],
        'group_id'=> $rows['group_id'],
        'date_of_joining'=> $rows['date_of_joining'],
        'print_bank_details'=> $rows['print_bank_details'],
        'account_holder_name'=> $account_holder_name,
        'account_name'=> $account_name,
        'ifsc_code'=> $ifsc_code,
        'account_no'=> $account_no,
        'branch_address'=> $branch_address,
        'account_type'=> $account_type,
        );
    }

    if (count($result) < 50) {
        return array('total_rows' => $totalrows, 'staff_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'staff_info' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_staff") {
    $institution_id = trim($postdata['institution_id']);
    
    if (isset($postdata['branch_id']) and !empty($postdata['branch_id'])) {
        $branch_id = trim($postdata['branch_id']);
    } else {
        $branch_id = null;
    }
    $limit = $postdata['limit'];
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }
    

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getStaff($conn_rjllearning_specific, $institution_id, $branch_id,$search_string,$limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getStaff($conn_rjllearning_specific, $institution_id, $branch_id,$search_string, $limit, null);
        successreturn($success);
    }
}
